// package web_api -- веб-сервер для API
package web_api

import (
	"fmt"
	"net/http"
	"strings"
	"time"
	"wartank/pkg/alias"
	"wartank/pkg/components/kernel/logger"
	"wartank/pkg/types"

	"github.com/gofiber/fiber/v2"
)

// ВебАпи -- веб-сервер для API
type ВебАпи struct {
	серв   types.ИСервер
	файбер fiber.App
	лог    types.ИЛоггер
}

// НовВебАпи -- возвращает новый веб-сервер для API
func НовВебАпи(вебСервер types.ИВебСервер) *ВебАпи {
	лог := logger.НовЛоггер("ВебАпи")
	лог.Паника(вебСервер == nil, "НовВебАпи(): ИВебСервер==nil")
	сам := &ВебАпи{
		серв:   вебСервер.Сервер(),
		файбер: *вебСервер.Файбер(),
		лог:    лог,
	}
	сам.файбер.Post("/api/login", сам.логин)
	сам.файбер.Post("/api/add_bot", сам.добавитьБота)
	сам.файбер.Get("/api/uptime", сам.аптаймСервер)
	сам.файбер.Get("/api/count_start", сам.стартНомер)

	сам.файбер.Get("/api/bot/:number/mine/level", сам.шахтаУровень)
	сам.файбер.Get("/api/bot/:number/mine/mode", сам.шахтаРежим)
	сам.файбер.Get("/api/bot/:number/mine/count_product", сам.шахтаРаботаКоличество)
	сам.файбер.Get("/api/bot/:number/mine/name_product", сам.шахтаРаботаИмя)
	сам.файбер.Get("/api/bot/:number/mine/back_time", сам.шахтаВремяОсталось)
	сам.файбер.Get("/api/bot/:number/mine/log", сам.шахтаЛог)

	сам.файбер.Get("/api/bot/:number/tank/fuel", сам.танкТопливо)
	сам.файбер.Get("/api/bot/:number/angar/silver", сам.ангарСеребро)

	сам.файбер.Get("/api/bot/:number/polygon/level", сам.полигонУровень)
	сам.файбер.Get("/api/bot/:number/polygon/mode", сам.полигонРежим)
	сам.файбер.Get("/api/bot/:number/polygon/count_product", сам.полигонРаботаКоличество)
	сам.файбер.Get("/api/bot/:number/polygon/name_product", сам.полигонРаботаИмя)
	сам.файбер.Get("/api/bot/:number/polygon/back_time", сам.полигонВремяОсталось)

	сам.файбер.Get("/api/bot/:number/arsenal/level", сам.арсеналУровень)
	сам.файбер.Get("/api/bot/:number/arsenal/mode", сам.арсеналРежим)
	сам.файбер.Get("/api/bot/:number/arsenal/count_product", сам.полигонРаботаКоличество)
	сам.файбер.Get("/api/bot/:number/arsenal/name_product", сам.арсеналРаботаИмя)
	сам.файбер.Get("/api/bot/:number/arsenal/back_time", сам.арсеналВремяОсталось)
	сам.файбер.Get("/api/bot/:number/arsenal/log", сам.арсеналЛог)
	return сам
}

// Возвращает имя производства снаряда на оружейке
func (сам *ВебАпи) арсеналРаботаИмя(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Тип: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Тип: нет такого бота]")
	}
	имя := бот.Ангар().База().Арсенал().ПродуктИмяСейчас()
	if имя == "" {
		return кнт.SendString("[Тип: пустое имя]")
	}
	return кнт.SendString("[Тип: " + имя + "]")
}

// Возвращает режим оружейки
func (сам *ВебАпи) арсеналРежим(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Режим: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Режим: нет такого бота]")
	}
	сценаРежим := бот.Ангар().База().Арсенал().АренаСостояние()
	стрРежим := fmt.Sprint(сценаРежим.Состояние())
	if стрРежим == "" {
		return кнт.SendString("[Режим: пустой режим]")
	}
	return кнт.SendString("[Режим: " + стрРежим + "]")
}

// Возвращает уровень арсенала
func (сам *ВебАпи) арсеналУровень(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Уровень: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Уровень: нет такого бота]")
	}
	уровень := бот.Ангар().База().Арсенал().Уровень()
	стрУровень := fmt.Sprint(уровень.Получ())
	if стрУровень == "" {
		return кнт.SendString("[Уровень: пустой уровень]")
	}
	return кнт.SendString("[Уровень: " + стрУровень + "]")
}

// Возвращает время, которое осталось на арсенале
func (сам *ВебАпи) арсеналВремяОсталось(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Время: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Время: нет такого бота]")
	}
	время := бот.Ангар().База().Арсенал().ВремяОстат()
	стрВремя := время.String()
	if стрВремя == "" {
		return кнт.SendString("[Время: пустой остаток времени]")
	}
	return кнт.SendString("[Время: " + стрВремя + "]")
}

// Возвращает лог арсенала
func (сам *ВебАпи) арсеналЛог(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Время: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Время: нет такого бота]")
	}
	лог := бот.Ангар().База().Арсенал().ВебЛог().Отладка()
	if лог == "" {
		return кнт.SendString("[Пустой лог арсенала]")
	}
	лог = strings.ReplaceAll(лог, "\n\n", "<br>")
	лог = strings.ReplaceAll(лог, "\n", "<br>")
	return кнт.SendString(лог)
}

// Возвращает время, которое осталось на полигоне
func (сам *ВебАпи) полигонВремяОсталось(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Время: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Время: нет такого бота]")
	}
	время := бот.Ангар().База().Полигон().ВремяОстат()
	стрВремя := время.String()
	if стрВремя == "" {
		return кнт.SendString("[Время: пустой остаток времени]")
	}
	return кнт.SendString("[Время: " + стрВремя + "]")
}

// Возвращает имя добычи ресурса на полигоне
func (сам *ВебАпи) полигонРаботаИмя(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Тип: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Тип: нет такого бота]")
	}
	имя := бот.Ангар().База().Полигон().ПродуктИмяСейчас()
	if имя == "" {
		return кнт.SendString("[Тип: пустое имя]")
	}
	return кнт.SendString("[Тип: " + имя + "]")
}

// Возвращает количество добычи на полигоне
func (сам *ВебАпи) полигонРаботаКоличество(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Кол: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Кол: нет такого бота]")
	}
	колич := бот.Ангар().База().Полигон().ПродуктКолСейчас()
	стрКолич := fmt.Sprint(колич)
	if стрКолич == "" {
		return кнт.SendString("[Кол: пустое кол]")
	}
	return кнт.SendString("[Кол: +" + стрКолич + "]")
}

// Возвращает режим полигона
func (сам *ВебАпи) полигонРежим(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Режим: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Режим: нет такого бота]")
	}
	сценаРежим := бот.Ангар().База().Полигон().АренаСостояние()
	стрРежим := fmt.Sprint(сценаРежим.Состояние())
	if стрРежим == "" {
		return кнт.SendString("[Режим: пустой режим]")
	}
	return кнт.SendString("[Режим: " + стрРежим + "]")
}

// Возвращает уровень полигона
func (сам *ВебАпи) полигонУровень(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Уровень: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Уровень: нет такого бота]")
	}
	уровень := бот.Ангар().База().Полигон().Уровень()
	стрУровень := fmt.Sprint(уровень.Получ())
	if стрУровень == "" {
		return кнт.SendString("[Уровень: пустой уровень]")
	}
	return кнт.SendString("[Уровень: " + стрУровень + "]")
}

// Возвращает количество серебра в ангаре
func (сам *ВебАпи) ангарСеребро(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Серебро: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Серебро: нет такого бота]")
	}
	серебро := бот.Ангар().СереброВсего().Получ()
	if серебро == 0 {
		return кнт.SendString("[Серебро: пустое кол]")
	}
	стрСеребро := fmt.Sprint(серебро)
	return кнт.SendString("[Серебро: " + стрСеребро + "]")
}

// Возвращает количество топлива в танке
func (сам *ВебАпи) танкТопливо(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Топливо: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Топливо: нет такого бота]")
	}
	топливо := бот.Ангар().Топливо().Получ()
	if топливо == 0 {
		return кнт.SendString("[Топливо: пустое кол]")
	}
	стрТопливо := fmt.Sprint(топливо)
	return кнт.SendString("[Топливо: " + стрТопливо + "]")
}

// Возвращает имя добычи ресурса в шахте
func (сам *ВебАпи) шахтаРаботаИмя(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Тип: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Тип: нет такого бота]")
	}
	имя := бот.Ангар().База().Шахта().ПродуктИмяСейчас()
	if имя == "" {
		return кнт.SendString("[Тип: пустое имя]")
	}
	return кнт.SendString("[Тип: " + имя + "]")
}

// Возвращает количество добычи в шахте
func (сам *ВебАпи) шахтаРаботаКоличество(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Кол: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Кол: нет такого бота]")
	}
	колич := бот.Ангар().База().Шахта().ПродуктКолСейчас()
	стрКолич := fmt.Sprint(колич)
	if стрКолич == "" {
		return кнт.SendString("[Кол: пустое кол]")
	}
	return кнт.SendString("[Кол: " + стрКолич + "]")
}

// Возвращает режим шахты
func (сам *ВебАпи) шахтаРежим(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Режим: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Режим: нет такого бота]")
	}
	сценаРежим := бот.Ангар().База().Шахта().АренаСостояние()
	стрРежим := fmt.Sprint(сценаРежим.Состояние())
	if стрРежим == "" {
		return кнт.SendString("[Режим: пустой режим]")
	}
	return кнт.SendString("[Режим: " + стрРежим + "]")
}

// Возвращает уровень шахты
func (сам *ВебАпи) шахтаУровень(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Уровень: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Уровень: нет такого бота]")
	}
	уровень := бот.Ангар().База().Шахта().Уровень()
	стрУровень := fmt.Sprint(уровень.Получ())
	if стрУровень == "" {
		return кнт.SendString("[Уровень: пустой уровень]")
	}
	return кнт.SendString("[Уровень: " + стрУровень + "]")
}

// Возвращает лог шахты
func (сам *ВебАпи) шахтаЛог(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Время: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Время: нет такого бота]")
	}
	лог := бот.Ангар().База().Шахта().ВебЛог().Отладка()
	if лог == "" {
		return кнт.SendString("[Пустой лог шахты]")
	}
	лог = strings.ReplaceAll(лог, "\n\n", "<br>")
	лог = strings.ReplaceAll(лог, "\n", "<br>")
	return кнт.SendString(лог)
}

// Возвращает время, которое осталось на шахте
func (сам *ВебАпи) шахтаВремяОсталось(кнт *fiber.Ctx) error {
	номер, ош := кнт.ParamsInt("number")
	if ош != nil {
		сообщ := fmt.Sprintf("[Время: неправильный номер бота(%q), err=%v]", номер, ош.Error())
		return кнт.SendString(сообщ)
	}
	ботНомер := alias.БотНомер(номер)
	бот := сам.серв.ServBots().Get(ботНомер)
	if бот == nil {
		return кнт.SendString("[Время: нет такого бота]")
	}
	время := бот.Ангар().База().Шахта().ВремяОстат()
	стрВремя := время.String()
	if стрВремя == "" {
		return кнт.SendString("[Время: пустой остаток времени]")
	}
	return кнт.SendString("[Время: " + стрВремя + "]")
}

// Возвращает счётчик запусков сервера
func (сам *ВебАпи) стартНомер(кнт *fiber.Ctx) error {
	return кнт.SendString("[Старт: " + fmt.Sprint(сам.серв.Стат().СчётСтарт()) + "]")
}

// Возвращает аптайм сервера
func (сам *ВебАпи) аптаймСервер(кнт *fiber.Ctx) error {
	return кнт.SendString("[Аптайм: " + сам.серв.Стат().ВремяВсего() + "]")
}

type AddBotRequest struct {
	Логин_ string `json:"login" form:"login_bot"`
	Пароль string `json:"password" form:"password_bot"`
}

// Запрос добавления нового бота на ботоферму
func (сам *ВебАпи) добавитьБота(кнт *fiber.Ctx) error {
	запрос := &AddBotRequest{}
	if err := кнт.BodyParser(запрос); err != nil {
		return кнт.Render("add_bot", fiber.Map{
			"err": "ошибка в разборе формы",
		})
	}
	сам.лог.Отладка("добавитьБота(): : %#+v\n", запрос)
	if запрос.Логин_ == "" {
		return кнт.Render("add_bot", fiber.Map{
			"err": "пустой логин бота",
		})
	}
	if запрос.Пароль == "" {
		return кнт.Render("add_bot", fiber.Map{
			"err": "пустой пароль бота",
		})
	}
	if ош := сам.серв.ServBots().НовБот(запрос.Логин_, запрос.Пароль, true); ош != nil {
		return кнт.Render("add_bot", fiber.Map{
			"err": ош.Error(),
		})
	}
	return кнт.Redirect("/gui/list_bot")
}

type LoginRequest struct {
	Логин_            string `json:"login" form:"login"`
	Пароль_           string `json:"password" form:"password"`
	КонтрольноеСлово_ string `json:"control_word" form:"control_word"`
}

// Вызывается при попытке войти
func (сам *ВебАпи) логин(кнт *fiber.Ctx) error {
	запрос := new(LoginRequest)
	if err := кнт.BodyParser(запрос); err != nil {
		return кнт.JSON(fiber.Map{
			"status": "ошибка в разборе формы",
		})
	}
	сам.лог.Инфо("ВебАпи.логин(): : %#+v\n", *запрос)
	if запрос.Логин_ == "" || запрос.Пароль_ == "" {
		return кнт.Render("login", fiber.Map{
			"err": "пустой логин/пароль",
		})
	}

	if запрос.Логин_ != "svi" || запрос.Пароль_ != "Lera_07091978" {
		return кнт.Render("login", fiber.Map{
			"err": "ошибка логина/пароля",
		})
	}
	кнт.Cookie(&fiber.Cookie{
		Name:     "login",
		Value:    "svi",
		Expires:  time.Now().Add(24 * time.Hour),
		HTTPOnly: true,
	})
	return кнт.Redirect("/gui/list_bot", http.StatusSeeOther)
}
